/**
 * 
 */
package com.ejie.ad74a.process;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.ejie.ad74a.exception.BatchProcessException;
import com.ejie.ad74a.model.Ayuntamiento;
import com.ejie.ad74a.model.Procesos;
import com.ejie.ad74a.service.CopagoAytoService;
import com.ejie.ad74a.service.ProcesosService;
import com.ejie.ad74a.util.constantes.EstadosProcesosBatchEnum;
import com.ejie.ad74a.util.constantes.ProcesosBatchEnum;

/**
 * Proceso para la generacion de copagos de ayuntamientos.
 * 
 * El proceso recorre ayuntamientos con pisos tutelados y genera factura y
 * liquidacion si aplica en funcion de la periodicidad y el dia de facturacion
 * configurado en el ayto
 * 
 * El proceso no recibe parametros.
 * 
 * @author BICUGUAL
 *
 */
@Component(value = "copagosAytos")
public class CopagoAytosProcess implements IProcess {

	private static final Logger logger = LoggerFactory.getLogger(CopagoAytosProcess.class);

	@Autowired
	CopagoAytoService copAytoService;
	
	@Autowired
	ProcesosService procesosService;

	/**
	 * Metodo de ejecucion del proceso.
	 * 
	 * @param arg[0] : idProceso tabla AD74A98T00
	 * 
	 * Formato del parámetro: @@idProceso@@
	 */
	@Override
	public void execute(String... args) throws BatchProcessException {

		
		Procesos proceso = new Procesos();		
		try {
			String params = Arrays.asList(args).stream().map(i -> i).collect(Collectors.joining(", "));
			
			logger.debug("Params: {}", params);
			
			String idProceso = args.length == 1 ? args[0] : null;

			List<Ayuntamiento> lstAyuntamientos = copAytoService.getLstAyuntamientos();
			
			// Buscar si existe el proceso en bbdd
			boolean addProceso = false;
			if(idProceso == null || "".equals(idProceso)) {
				addProceso = true;
			} else {
				proceso = new Procesos(Long.valueOf(idProceso));
				proceso = this.procesosService.find(proceso);
				addProceso = null == proceso? true: false;					
			}	
			
			if(addProceso) {
				// Creamos un proceso nuevo
				// 1- Insertar el nuevo proceso en la tabla AD74A98T00
				proceso = new Procesos();
				proceso.setEstado98(EstadosProcesosBatchEnum.PENDIENTE.getId());
				proceso.setUsuAlta98("AD74A");				
				proceso.setTipoProceso98(ProcesosBatchEnum.COPAGO_AYTOS.getId());
				proceso.setProceso98(lstAyuntamientos.size() + "");
				proceso = this.procesosService.add(proceso);
			}

			this.procesosService.actualizarAIniciado(proceso);
			
			lstAyuntamientos.stream().forEach(ayto -> {
				try {
					copAytoService.generarFacturacionAyto(ayto);
				} catch (Exception e) {
					logger.error("Error en el procesamiento ayto: {}", ayto.getDescEs(), e);
				}
			});
			this.procesosService.actualizarAFinalizado(proceso);	
			
		} catch (Exception e) {
			if(proceso != null && proceso.getIdProceso98() != null) {				
				proceso.setError98(e.getMessage().substring(0, Math.min(e.getMessage().length(), 799))); // Máximo 800
				this.procesosService.actualizarAError(proceso);
			}
			throw new BatchProcessException(e);
		}

	}

}
